## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 19;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Not packaged: python-markuppy
%bcond markuppy 0

Name:             python-tablib
Version:          3.0.0
Release:          %autorelease
Summary:          Format agnostic tabular data library (XLS, JSON, YAML, CSV, etc.)

License:          MIT
URL:              http://github.com/kennethreitz/tablib
Source:           %{pypi_source tablib}

BuildArch:        noarch

BuildRequires:  python3-devel

BuildRequires:  %{py3_dist pytest}

%global _description %{expand: \
Tablib is a format-agnostic tabular dataset library, written in Python.}

%description %_description

%package -n python3-tablib
Summary:        %{summary}

%if %{defined fc42} || %{defined fc41}
# For backwards-compatibility with manual Requires, keep hard dependencies on
# the corresponding extras metapackages.
Requires:       python3-tablib+ods = %{version}-%{release}
Requires:       python3-tablib+xls = %{version}-%{release}
Requires:       python3-tablib+xlsx = %{version}-%{release}
Requires:       python3-tablib+yaml = %{version}-%{release}
%endif

%description -n python3-tablib %{_description}

%if %{with markuppy}
%global with_all 1
%endif

%pyproject_extras_subpkg -n python3-tablib cli ods pandas xls xlsx yaml
%if 0%{?with_all}
%pyproject_extras_subpkg -n python3-tablib all
%endif
%if %{with markuppy}
%pyproject_extras_subpkg -n python3-tablib html
%endif

%prep
%autosetup -n tablib-%{version}
# Remove shebangs from non-script sources. The find-then-modify pattern
# preserves mtimes on sources that did not need to be modified.
find 'src' -type f -name '*.py' \
    -exec gawk '/^#!/ { print FILENAME }; { nextfile }' '{}' '+' |
  xargs -r sed -r -i '1{/^#!/d}'
%if %{without markuppy}
sed -r -i 's/^from MarkupPy /# &/' tests/test_tablib.py
%endif
# https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_linters
sed -r -i 's/ --cov(=|-report )[^ ]+//g' pytest.ini

%generate_buildrequires
%{pyproject_buildrequires \
    %{?with_all:-x all} \
    -x cli \
    %{?with_markuppy:-x html} \
    -x ods \
    -x pandas \
    -x xls \
    -x xlsx \
    -x yaml}

%build
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files -l tablib

%check
%if %{without markuppy}
k="${k-}${k+ and }not HTMLTests"
k="${k-}${k+ and }not (TablibTestCase and test_book_export_no_exceptions)"
k="${k-}${k+ and }not (TablibTestCase and test_datetime_append)"
k="${k-}${k+ and }not (TablibTestCase and test_separator_append)"
k="${k-}${k+ and }not (TablibTestCase and test_unicode_append)"
%endif
%pytest -k "${k-}" -v
 
%files -n python3-tablib -f %{pyproject_files}
%doc AUTHORS
%doc HISTORY.md
%doc README.md

%changelog
## START: Generated by rpmautospec
* Sun May 18 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.0-19
- Run the tests

* Sun May 18 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.0-18
- Remove shebangs from non-script sources

* Sun May 18 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.0-17
- Port to pyproject-rpm-macros
- Add metapackages for Python extras

* Sun May 18 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.0-16
- Package AUTHORS and HISTORY.md as documentation

* Sun May 18 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.0-15
- Reduce macro indirection in the spec file
- Do not use the deprecated zero-argument form of %%pypi_source

* Sun May 18 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.0-14
- Update Summary/description from upstream; drop outdated format list

* Sat Jan 18 2025 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Fri Jul 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Fri Jun 07 2024 Python Maint <python-maint@redhat.com> - 3.0.0-10
- Rebuilt for Python 3.13

* Fri Jan 26 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Jan 22 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Tue Jun 13 2023 Python Maint <python-maint@redhat.com> - 3.0.0-6
- Rebuilt for Python 3.12

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon Jun 13 2022 Python Maint <python-maint@redhat.com> - 3.0.0-3
- Rebuilt for Python 3.11

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

%autochangelog

## END: Generated by rpmautospec
